<script lang="ts">
	export let filteredFiles: Array<string> | null = null
	export let uploadedFiles: Array<string> = []

	// used only on "Edit" mode
	export let previousFiles: Array<string> | null = null
	export let removedFiles: Array<string> | null = null

	let fileInput = null
	let editMode = previousFiles !== null && removedFiles !== null

	function handleChange() {
		filteredFiles = [...fileInput.files].map((file) => file.name)
		if (editMode) {
			uploadedFiles = [...filteredFiles]
			// if we add a file that was previously on the array removedFiles, remove this file from the array removedFiles
			removedFiles = removedFiles.filter((file) => !filteredFiles.includes(file))
			// only the files that were in previousFiles should remain on removedFiles after a file update
			removedFiles = removedFiles.filter((file) => previousFiles.includes(file))
			const unionPreviousAndFilteredFiles = [...new Set([...previousFiles, ...filteredFiles])]
			filteredFiles = unionPreviousAndFilteredFiles.filter((file) => !removedFiles.includes(file))
		}
	}

	function removeFile(event) {
		const fileToRemove = event.target.querySelector(".file-name").textContent
		filteredFiles = filteredFiles.filter((file) => file !== fileToRemove)
		if (editMode) {
			if (previousFiles.includes(fileToRemove)) {
				removedFiles = removedFiles.concat(fileToRemove)
			}
		}
	}
</script>

<label class="form-input cursor-pointer" for="datapackage-resource">
	<input
		type="file"
		name="datapackage-resource"
		required={filteredFiles.length === 0}
		multiple
		on:change={handleChange}
		bind:this={fileInput}
	/>
	{#if filteredFiles}
		<ul class="filtered-files">
			{#each filteredFiles as file}
				<li on:click={removeFile}><span class="file-name">{file}</span> ❌</li>
			{/each}
		</ul>
	{/if}
</label>

<!-- hack to hide the text about the files on the input -->
<style>
	input {
		color: transparent;
	}
</style>
